{-# LANGUAGE OverloadedStrings #-}
import Turtle
import qualified Filesystem.Path.CurrentOS as FP
import Prelude hiding (FilePath)
import qualified Data.Text as T
import PSO (defaultParameters, runPSO)


argsTW [cw, vw] =
  [ "-m mode483"
  , "-flag TERM_CONST_WEIGHT", cw
  , "-flag TERM_VARIABLE_WEIGHT", vw
  ]

pathTW [cw, vw] = ["lresults-cw", cw, "-vw", vw]

boundsTW = [(-1.0, 2.0), (-1.0, 2.0)]


argsSimp [pw, nw] =
  [ "-m mode483"
  , "-flag SIMP_PWEIGHT", pw
  , "-flag SIMP_NWEIGHT", nw
  ]

pathSimp [pw, nw] = ["lresults-pw", pw, "-nw", nw]

boundsSimp = [(-2.0, 2.0), (-2.0, 2.0)]


mkArgs v = "-m mode483" : map (\ (f, v) -> T.unwords ["-flag", f, v]) v

argsBayes [bw, fw, lw, iw, rw] = mkArgs
  [ ("BAYES_WEIGHT" , bw)
  , ("BAYES_FWEIGHT", fw)
  , ("BAYES_LWEIGHT", lw)
  , ("BAYES_IWEIGHT", iw)
  , ("BAYES_RWEIGHT", rw)
  ]

pathBayes [bw, fw, lw, iw, rw] =
  ["lresults-bayes/lresults-bw", bw, "-fw", fw, "-lw", lw, "-iw", iw, "-rw", rw]

boundsBayes = [(0.0, 1.0), (-2.0, 0.0), (6.0, 0.0), (-2.0, 0.0), (0.05, 0.0)]


numTheorems fp = fold (grep (has "Theorem") (ls fp >>= input)) countLines

run args path v = do
  export "ARGS" $ T.unwords $ args vd
  export "LRESULTS" $ p
  proc "make" ["-j3", "lresults"] empty
  numTheorems $ FP.fromText p

  where vd = map repr v
        p = T.concat $ path vd


main = runPSO defaultParameters boundsBayes $ run argsBayes pathBayes
