This file describes how to set up an evaluation environment for Satallax
with internal guidance, and how to then perform and interpret the evaluation.


Evaluation setup
================

We assume the directory in which this file is placed to be $(EVAL).
To prepare the evaluation, do:

1. Get a THF training set and place it into $(THF).
2. Get our modified Satallax version and place it into $(SATALLAX).
3. Compile Satallax via `cd $(SATALLAX) && make`.
   Hint: To change the training data post-processing options,
   modify the parameters at the beginning of $(SATALLAX)/src/learn/training.ml.
4. Create links to the Satallax binaries in the $(EVAL) directory, via
   `cd $(EVAL) && ln -s $(SATALLAX)/*.native`.
5. Create links to the THF training set via `ln -s $(THF) $(EVAL)/problems`.


Running the evaluation
======================

To run an offline evaluation:

    make training
    make offline

To run an online evaluation:

    make online

The files created in the `training` directory are training files for
those problems that Satallax was able to solve without internal guidance.
The files created in the `offline` respectively `online` directories are
training data for the problems that were solved with internal guidance.

You may run the offline evaluation in parallel (with `make -j3`, for example).
To offline evaluation, however, should not be run in parallel.
That is because there, every prover run depends on the previous one.


Some useful commands
--------------------

To get the number of problems solved in online mode:

    ls online/* | wc -l

To find those problems solved in offline mode, but not with stock Satallax:

    comm -23 <(ls offline/ | sort) <(ls training/ | sort)


Bonus: Particle Swarm Optimisation
==================================

The particle swarm optimiser is in the PSO subdirectory.
To install it, we recommend getting `stack` from <http://www.haskellstack.org>
and run:

    stack install PSO

Then, you can adapt Run.hs to your liking and run

    runghc Run.hs

to start the optimisation.
(You might need to execute `stack exec bash` before the previous step.)
